jQuery(
	function ($) {
		if (widget_info.widget_protected !== '1') {
			return;
		}
		if (widget_info.widget_limit === '') {
			widget_info.widget_limit = '-1';
		}
		var widgetsidebar = widget_info.widget_sidebar;
		var sidebarLimitsArgs = {};
		sidebarLimitsArgs['BP_Widget_CTA_top'] = widget_info.widget_protected;
		sidebarLimitsArgs[widgetsidebar] = widget_info.widget_limit;

		var sidebarId = $( '.ui-sortable' ).attr( 'id' ),
		sidebar = $( '#' + sidebarId );
		var sidebarLimits = sidebarLimitsArgs;
		var realSidebars = $( '#widgets-right div.widgets-sortables' );
		var availableWidgets = $( '#widget-list' ).children( '.widget' );
		console.log( sidebarLimits );
		var checkLength = function (sidebar, delta) {
			var sidebarId = sidebar.id;

			if (undefined === sidebarLimits[sidebarId]) {
				return;
			}
			if (sidebarLimits[sidebarId] !== '-1') {
				// This is a limited sidebar
				// Find out how many widgets it already has
				var list = $( sidebar ).sortable( 'toArray' );
				var widgets = cleanArray( list );
				$( sidebar ).toggleClass( 'sidebar-full', sidebarLimits[sidebarId] <= widgets.length + (delta || 0) );
				$( sidebar ).toggleClass( 'sidebar-morethanfull', sidebarLimits[sidebarId] < widgets.length + (delta || 0) );
				$( sidebar ).toggleClass( 'sidebar-notfull', sidebarLimits[sidebarId] > widgets.length + (delta || 0) );

				if (sidebarLimits[sidebarId] < widgets.length + delta && ( delta !== 0 || null)) {
					checkLength( sidebar );
				}
				// If it's not 'What we do widget' or the area description/name, remove it.
				if (sidebarLimits[sidebarId] < widgets.length) {
					// $(this).children(':last')[0].remove();
					$( sidebar ).children( ':last' ).remove();
					checkLength( sidebar );
				} // end if

				var notFullSidebars = $( 'div.widgets-sortables' ).not( '.sidebar-full' );
				availableWidgets.draggable(
					{
						connectToSortable: notFullSidebars
					}
				);
				availableWidgets.draggable( 'option', 'connectToSortable', notFullSidebars );
				realSidebars.sortable(
					{
						connectWith: notFullSidebars
					}
				);
				realSidebars.sortable( 'option', 'connectWith', notFullSidebars );
			}
		};

		/**
		 * Determines if the specified element is the widget area's description.
		 *
		 * @param  array    sortableArray     Array from sortable containing empty keys
		 * @return array    newArrary     Array no longer containing any "falsy" values:
		 * undefined, null, 0, false, NaN and ''
		 */
		function cleanArray(sortableArray) {
			var newArray = new Array();
			for (var i = 0; i < sortableArray.length; i++) {
				if (sortableArray[i]) {
					newArray.push( sortableArray[i] );
				}
			}
			return newArray;
		}

		/**
		 * Determines if the specified element is the widget area's description.
		 *
		 * @param  object    $      A reference to jQuery
		 * @param  element   $elem  The element used to evaluate
		 * @return boolean          True if it's the widgetized area's description; otherwise, false
		 */
		function isWidgetAreaDescription($, $elem) {
			return $elem.hasClass( 'sidebar-description' );
		} // end isWidgetAreaDescription

		/**
		 * Determines if the specified element is the widget area's name.
		 *
		 * @param  object    $      A reference to jQuery
		 * @param  element   $elem  The element used to evaluate
		 * @return boolean          True if it's the widgetized area's name; otherwise, false
		 */
		function isWidgetAreaName($, $elem) {
			return $elem.hasClass( 'sidebar-name' );
		} // end isWidgetAreaName

		/**
		 * Determines if the specified element is a what we do widget
		 *
		 * @param  object    $      A reference to jQuery
		 * @param  element   div    The div element to evaluate
		 * @return boolean          True if the element is the what we do widget; otherwise, false.
		 */
		function isWhatWeDoWidget($, div) {

			return 1 === $( div ).children( '.widget-inside' ).children( 'form' ).length &&
			'brewpixel-widget-content-boxes' === $( div ).children( '.widget-inside' ).children( 'form' ).children( '.id_base' ).val();

		} // end isWhatWeDoWidget

		$( '#' + widgetsidebar ).sortable(
			{

				update: function (evt, ui) {

					// Iterate through each of the child elements...
					$( this ).children().each(
						function () {

							// If it's not 'What we do widget' or the area description/name, remove it.
							if ( ! ( isWhatWeDoWidget( $, $( this ) ) || isWidgetAreaName( $, $( this ) ) || isWidgetAreaDescription( $, $( this ) ) )) {
								$( this ).remove();
							} // end if

						}
					);

				}  // end update

			}
		);
		$( '#BP_Widget_CTA_top' ).sortable(
			{

				update: function (evt, ui) {

					// Iterate through each of the child elements...
					$( this ).children().each(
						function () {

							// If it's not 'What we do widget' or the area description/name, remove it.
							if ( ! ( isWhatWeDoWidget( $, $( this ) ) || isWidgetAreaName( $, $( this ) ) || isWidgetAreaDescription( $, $( this ) ) )) {
								$( this ).remove();
							} // end if
						}
					);

				}  // end update

			}
		);
		// Check existing sidebars on startup
		realSidebars.map(
			function () {
				checkLength( this );
			}
		);

		// Update when dragging to this (sort-receive)
		// and away to another sortable (sort-remove)
		realSidebars.on(
			'sortremove', function (event, ui) {
				checkLength( this, -1 );
			}
		);

		realSidebars.on(
			'sortreceive sortremove', function (event, ui) {
				checkLength( this );
			}
		);

		realSidebars.bind(
			'sortreceive', function (event, ui) {
				var sidebarId = $( '.ui-sortable' ).attr( 'id' ),
				sidebar = $( '#' + sidebarId );
				var sidebarLimits = sidebarLimitsArgs;
				var id = jQuery( ui.item ).attr( 'id' );
				var areaId = jQuery( $( this ).closest( 'div.widgets-sortables' ).attr( 'id' ) );
				var sidebarId = areaId.selector;

				if (undefined === sidebarLimits[sidebarId]) {
					checkLength( $( this ).closest( 'div.widgets-sortables' )[0], 0 );
				} else {
					checkLength( $( this ).closest( 'div.widgets-sortables' )[0], 1 );
				}
			}
		);

		// Update when dragging back to the "Available widgets" stack
		realSidebars.bind(
			'sortstop', function (event, ui) {
				if (ui.item.hasClass( 'deleting' )) {
					checkLength( this, -1 );
				} else {
					// checkLength(this);
				}
			}
		);

		// Update when the "Delete" link is clicked
		$( 'a.widget-control-remove' ).live(
			'click', function () {
				console.log( 'Delete' );
				checkLength( $( this ).closest( 'div.widgets-sortables' )[0], -1 );
			}
		);

		// Update when the "Save" link is clicked save-widget
		var chooser = $( '.widgets-chooser' );
		$( document ).on(
			'click','.button-primary',function (chooser){
				var chooser = $( '.widgets-chooser' );
				console.log( 'chooser= ' + chooser );
				var sidebarId = chooser.find( '.widgets-chooser-selected' ).data( 'sidebarId' ),
				sidebar = $( '#' + sidebarId );
				var sidebarLimits = sidebarLimitsArgs;
				if (undefined === sidebarLimits[sidebarId]) {
					checkLength( $( this ) );
				} else {
					var sidebarId = jQuery( document.getElementById( sidebarId ) );
					checkLength( sidebar[0] );
				}
			}
		);
	}
);
